extern int main(void);
void _reset(void);
extern void __StackTop(void);

#define ALIAS(f) __attribute__ ((weak, alias (#f)))

/* Standard-Handler fuer nicht implementierte Interrupt-Service-Routinen */
void Default_Interrupt_Handler(void) __attribute__ ((weak));

void NMI_Handler(void) ALIAS(Default_Interrupt_Handler);
void HardFault_Handler(void) ALIAS(Default_Interrupt_Handler);
void MemManage_Handler(void) ALIAS(Default_Interrupt_Handler);
void BusFault_Handler(void) ALIAS(Default_Interrupt_Handler);
void UsageFault_Handler(void) ALIAS(Default_Interrupt_Handler);
void SVC_Handler(void) ALIAS(Default_Interrupt_Handler);
void DebugMon_Handler(void) ALIAS(Default_Interrupt_Handler);
void PendSV_Handler(void) ALIAS(Default_Interrupt_Handler);
void SysTick_Handler(void) ALIAS(Default_Interrupt_Handler);

void WWDG_IRQHandler(void) ALIAS(Default_Interrupt_Handler);             // - 00 Window Watchdog
void PVD_IRQHandler(void) ALIAS(Default_Interrupt_Handler);              // - 01 PVD through EXTI Line detect
void TAMPER_IRQHandler(void) ALIAS(Default_Interrupt_Handler);           // - 02 Tamper
void RTC_IRQHandler(void) ALIAS(Default_Interrupt_Handler);              // - 03 RTC
void FLASH_IRQHandler(void) ALIAS(Default_Interrupt_Handler);            // - 04 Flash
void RCC_IRQHandler(void) ALIAS(Default_Interrupt_Handler);              // - 05 RCC
void EXTI0_IRQHandler(void) ALIAS(Default_Interrupt_Handler);            // - 06 EXTI Line 0
void EXTI1_IRQHandler(void) ALIAS(Default_Interrupt_Handler);            // - 07 EXTI Line 1
void EXTI2_IRQHandler(void) ALIAS(Default_Interrupt_Handler);            // - 08 EXTI Line 2
void EXTI3_IRQHandler(void) ALIAS(Default_Interrupt_Handler);            // - 09 EXTI Line 3
void EXTI4_IRQHandler(void) ALIAS(Default_Interrupt_Handler);            // - 10 EXTI Line 4
void DMA1_Channel1_IRQHandler(void) ALIAS(Default_Interrupt_Handler);    // - 11 DMA1 Channel 1
void DMA1_Channel2_IRQHandler(void) ALIAS(Default_Interrupt_Handler);    // - 12 DMA1 Channel 2
void DMA1_Channel3_IRQHandler(void) ALIAS(Default_Interrupt_Handler);    // - 13 DMA1 Channel 3
void DMA1_Channel4_IRQHandler(void) ALIAS(Default_Interrupt_Handler);    // - 14 DMA1 Channel 4
void DMA1_Channel5_IRQHandler(void) ALIAS(Default_Interrupt_Handler);    // - 15 DMA1 Channel 5
void DMA1_Channel6_IRQHandler(void) ALIAS(Default_Interrupt_Handler);    // - 16 DMA1 Channel 6
void DMA1_Channel7_IRQHandler(void) ALIAS(Default_Interrupt_Handler);    // - 17 DMA1 Channel 7
void ADC1_2_3_IRQHandler(void) ALIAS(Default_Interrupt_Handler);         // - 18 ADC1_2_3_IRQHandler
void USB_HP_CAN1_TX_IRQHandler(void) ALIAS(Default_Interrupt_Handler);   // - 19 USB High Priority or CAN1 TX
void USB_LP_CAN1_RX0_IRQHandler(void) ALIAS(Default_Interrupt_Handler);  // - 20 USB Low  Priority or CAN1 RX0
void CAN1_RX1_IRQHandler(void) ALIAS(Default_Interrupt_Handler);         // - 21 CAN1 RX1
void CAN1_SCE_IRQHandler(void) ALIAS(Default_Interrupt_Handler);         // - 22 CAN1 SCE
void EXTI9_5_IRQHandler(void) ALIAS(Default_Interrupt_Handler);          // - 23 EXTI Line 9..5
void TIM1_BRK_IRQHandler(void) ALIAS(Default_Interrupt_Handler);         // - 24 TIM1 Break
void TIM1_UP_IRQHandler(void) ALIAS(Default_Interrupt_Handler);          // - 25 TIM1 Update
void TIM1_TRG_COM_IRQHandler(void) ALIAS(Default_Interrupt_Handler);     // - 26 TIM1 Trigger and Commutation
void TIM1_CC_IRQHandler(void) ALIAS(Default_Interrupt_Handler);          // - 27 TIM1 Capture Compare
extern void TIM2_IRQHandler();/*void TIM2_IRQHandler(void) ALIAS(Default_Interrupt_Handler);*/             // - 28 TIM2
void TIM3_IRQHandler(void) ALIAS(Default_Interrupt_Handler);             // - 29 TIM3
void TIM4_IRQHandler(void) ALIAS(Default_Interrupt_Handler);             // - 30 TIM4
void I2C1_EV_IRQHandler(void) ALIAS(Default_Interrupt_Handler);          // - 31 I2C1 Event
void I2C1_ER_IRQHandler(void) ALIAS(Default_Interrupt_Handler);          // - 32 I2C1 Error
void I2C2_EV_IRQHandler(void) ALIAS(Default_Interrupt_Handler);          // - 33 I2C2 Event
void I2C2_ER_IRQHandler(void) ALIAS(Default_Interrupt_Handler);          // - 34 I2C2 Error
void SPI1_IRQHandler(void) ALIAS(Default_Interrupt_Handler);             // - 35 SPI1
void SPI2_IRQHandler(void) ALIAS(Default_Interrupt_Handler);             // - 36 SPI2
void USART1_IRQHandler(void) ALIAS(Default_Interrupt_Handler);           // - 37 USART1
void USART2_IRQHandler(void) ALIAS(Default_Interrupt_Handler);           // - 38 USART2
extern void USART3_IRQHandler();/*void USART3_IRQHandler(void) ALIAS(Default_Interrupt_Handler);*/           // - 39 USART3
void EXTI15_10_IRQHandler(void) ALIAS(Default_Interrupt_Handler);        // - 40 EXTI Line 15..10
void RTCAlarm_IRQHandler(void) ALIAS(Default_Interrupt_Handler);         // - 41 RTC Alarm through EXTI Line
void USBWakeUp_IRQHandler(void) ALIAS(Default_Interrupt_Handler);        // - 42 USB Wakeup from suspend

extern void DMA2_Stream4_IRQHandler();/*void DMA2_Stream4_IRQHandler(void) ALIAS(Default_Interrupt_Handler);*/    // - 60 DMA2 Stream 4
extern void ETH_IRQHandler();                                            // - 61 Ethernet global Interrupt handler

extern void (* const isr_vector[])(void) __attribute__ ((section(".isr_vector")));
void (* const isr_vector[])(void) = {
    &__StackTop,
    _reset,
    NMI_Handler,                       // The NMI handler
    HardFault_Handler,                 // The hard fault handler
    MemManage_Handler,                 // The MPU fault handler
    BusFault_Handler,                  // The bus fault handler
    UsageFault_Handler,                // The usage fault handler
    0,                                 // Reserved
    0,
    0,
    0,
    SVC_Handler,                       // SVCall handler
    DebugMon_Handler,                  // Debug monitor handler
    0,                                 // Reserved
    PendSV_Handler,                    // The PendSV handler
    SysTick_Handler,                   // The SysTick handler

    WWDG_IRQHandler,                   // - 00 Window Watchdog
    PVD_IRQHandler,                    // - 01 PVD through EXTI Line detect
    TAMPER_IRQHandler,                 // - 02 Tamper
    RTC_IRQHandler,                    // - 03 RTC
    FLASH_IRQHandler,                  // - 04 Flash
    RCC_IRQHandler,                    // - 05 RCC
    EXTI0_IRQHandler,                  // - 06 EXTI Line 0
    EXTI1_IRQHandler,                  // - 07 EXTI Line 1
    EXTI2_IRQHandler,                  // - 08 EXTI Line 2
    EXTI3_IRQHandler,                  // - 09 EXTI Line 3
    EXTI4_IRQHandler,                  // - 10 EXTI Line 4
    DMA1_Channel1_IRQHandler,          // - 11 DMA1 Channel 1
    DMA1_Channel2_IRQHandler,          // - 12 DMA1 Channel 2
    DMA1_Channel3_IRQHandler,          // - 13 DMA1 Channel 3
    DMA1_Channel4_IRQHandler,          // - 14 DMA1 Channel 4
    DMA1_Channel5_IRQHandler,          // - 15 DMA1 Channel 5
    DMA1_Channel6_IRQHandler,          // - 16 DMA1 Channel 6
    DMA1_Channel7_IRQHandler,          // - 17 DMA1 Channel 7
    ADC1_2_3_IRQHandler,               // - 18 ADC1_2_3_IRQHandler
    USB_HP_CAN1_TX_IRQHandler,         // - 19 USB High Priority or CAN1 TX
    USB_LP_CAN1_RX0_IRQHandler,        // - 20 USB Low  Priority or CAN1 RX0
    CAN1_RX1_IRQHandler,               // - 21 CAN1 RX1
    CAN1_SCE_IRQHandler,               // - 22 CAN1 SCE
    EXTI9_5_IRQHandler,                // - 23 EXTI Line 9..5
    TIM1_BRK_IRQHandler,               // - 24 TIM1 Break
    TIM1_UP_IRQHandler,                // - 25 TIM1 Update
    TIM1_TRG_COM_IRQHandler,           // - 26 TIM1 Trigger and Commutation
    TIM1_CC_IRQHandler,                // - 27 TIM1 Capture Compare
    TIM2_IRQHandler,                   // - 28 TIM2
    TIM3_IRQHandler,                   // - 29 TIM3
    TIM4_IRQHandler,                   // - 30 TIM4
    I2C1_EV_IRQHandler,                // - 31 I2C1 Event
    I2C1_ER_IRQHandler,                // - 32 I2C1 Error
    I2C2_EV_IRQHandler,                // - 33 I2C2 Event
    I2C2_ER_IRQHandler,                // - 34 I2C2 Error
    SPI1_IRQHandler,                   // - 35 SPI1
    SPI2_IRQHandler,                   // - 36 SPI2
    USART1_IRQHandler,                 // - 37 USART1
    USART2_IRQHandler,                 // - 38 USART2
    USART3_IRQHandler,                 // - 39 USART3
    EXTI15_10_IRQHandler,              // - 40 EXTI Line 15..10
    RTCAlarm_IRQHandler,               // - 41 RTC Alarm through EXTI Line
    USBWakeUp_IRQHandler,              // - 42 USB Wakeup from suspend
    0,                                 // - 43
    0,                                 // - 44
    0,                                 // - 45
    0,                                 // - 46
    0,                                 // - 47
    0,                                 // - 48
    0,                                 // - 49
    0,                                 // - 50
    0,                                 // - 51
    0,                                 // - 52
    0,                                 // - 53
    0,                                 // - 54
    0,                                 // - 55
    0,                                 // - 56
    0,                                 // - 57
    0,                                 // - 58
    0,                                 // - 59
    DMA2_Stream4_IRQHandler,           // - 60 DMA2_Stream4_IRQHandler
    ETH_IRQHandler                     // - 61 Ethernet global Interrupt handler
};

void _reset(void)
{
    /* hole die im Linker-Skript erstellen globalen Variablen */
    extern unsigned int __data_start__;
    extern unsigned int __data_end__;
    extern unsigned int __etext;
    extern unsigned int __bss_start__;
    extern unsigned int __bss_end__;

    unsigned int *src;
    unsigned int *dest;
    /* jetzt überschreiben wir alle Varaiblen in der .bss-Section mit 0 */
    dest = &__bss_start__;
    while (dest < &__bss_end__)
    {
        *dest++ = 0;
    }
    
    /* jetzt initialisieren wir alle .data-Variablen mit den */
    /* Daten, die im Flash abgelegt wurden */
    src = &__etext;
    dest = &__data_start__;
    while (dest < &__data_end__)
    {
        *dest++ = *src++;
    }
    
    /* und nun folgt endlich der Aufruf von main() */
    /* der return-wert wird nicht verwendet, man könnte also main als */
    /* void main(void) definieren und deklarieren, spart uU etwas Speicher */
    main();
    
    /* falls main() zurückkehrt: gehe in eine Endlosschleife */
    while(1) ;
}

void Default_Interrupt_Handler(void)
{
    while(1)
        ;
}
