#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>

#include "STM32F767.h"
#include "DAC.h"
#include "ADC.h"
#include "Timer.h"
#include "UART.h"
#include "ethernet.h"

extern volatile uint8_t *tx_buffer_ptr;
extern volatile uint32_t N_requested_frames;

int main()
{
    //setup_clock_HSI(216, 8, 2, 9, 7);    // HSI 16MHz
    setup_clock_HSE_bypass(216, 4, 2, 9, 7);    // HSE 8MHz crystal
    //setup_clock_HSE(216, 8, 2, 9, 7);    // HSE 16MHz crystal
    
    initGPIO();
    setPinDir(PORTA, 8, GPIO_OUTPUT);
    
    init_UART();
    
    send_string_UART("initializing ethernet... ");
    init_ethernet();
    send_string_UART("done.\n");
    
    /*
    send_string_UART("transmitting test frame... ");
    tx_buffer_ptr[(0*N_PACKET_BYTES) + 14 + 0] = 'H';
    transmit_ethernet_frame(0);
    send_string_UART("done.\n");
    
    send_string_UART("transmitting test frame... ");
    tx_buffer_ptr[(1*N_PACKET_BYTES) + 14 + 0] = 'e';
    transmit_ethernet_frame(1);
    send_string_UART("done.\n");
    
    send_string_UART("transmitting test frame... ");
    tx_buffer_ptr[(0*N_PACKET_BYTES) + 14 + 0] = 'l';
    transmit_ethernet_frame(0);
    send_string_UART("done.\n");
    
    send_string_UART("transmitting test frame... ");
    tx_buffer_ptr[(1*N_PACKET_BYTES) + 14 + 0] = 'o';
    transmit_ethernet_frame(1);
    send_string_UART("done.\n");
    */
    
    init_DAC();
    init_ADC();
    
    //init_TIM2();
    
    while(1)
    {
    }
    
    return 0;
}
